/* 
 * TI-NESulator project : cnrom.h
 *
 * CNROM Mapper
 *
 * Code Copyright © 2003 by TRAPIER Manoel
 *
 */

int cnrom_InitMapper(NesCart *cart)
{
	mLBank = cart->ROMBanks[0];

	mUBank = cart->ROMBanks[cart->nbROMBanks - 1];
	
	return 0;
}

int cnrom_MapperWriteHook(register word Addr,register byte Value)
{
	if ( Addr > 0x7FFF ) /* Try to write to the rom */
	{
		memcpy(ppu.Memory,Cart->VROMBanks[Value],0x2000);
		return 1;
	}
	return 0;
}
