//*scanf() implementation for TIGCCLIB
//WARNING: This implementation might accept broken format strings (for size
//         reasons). For example: "%1h2d" == "%h12d".
//Copyright (C) Kevin Kofler, 2002

typedef CALLBACK short (*__cbscanf_get_Callback_t) (void *param);
typedef CALLBACK void (*__cbscanf_unget_Callback_t) (short c, void *param);
short __cbscanf(register __cbscanf_get_Callback_t getfun asm("a0"),
                register __cbscanf_unget_Callback_t ungetfun asm("a1"),
                register void *param asm("a2"),
                register const char *format asm("a3"), ...);
short __vcbscanf(register __cbscanf_get_Callback_t getfun asm("a0"),
                 register __cbscanf_unget_Callback_t ungetfun asm("a1"),
                 register void *param asm("a2"),
                 register const char *format asm("a3"),
                 register va_list arglist asm("a6"));
CALLBACK short __fscanf_get(FILE *param);
CALLBACK void __fscanf_unget(short c, FILE *param);
#define fscanf(__file__,__format__...) \
        __cbscanf((__cbscanf_get_Callback_t)__fscanf_get,\
                  (__cbscanf_unget_Callback_t)__fscanf_unget,\
                  (void *)(__file__),__format__)
#define vfscanf(__file__,__format__,__arglist__) \
        __vcbscanf((__cbscanf_get_Callback_t)__fscanf_get,\
                   (__cbscanf_unget_Callback_t)__fscanf_unget,\
                   (void *)(__file__),(__format__),(__arglist__))
typedef struct {char *buffer; unsigned short pos;} __sscanf_string;
CALLBACK short __sscanf_get(__sscanf_string *param);
CALLBACK void __sscanf_unget(short c, __sscanf_string *param);
#define sscanf(__buffer__,__format__...) \
        ({__sscanf_string __param__={(__buffer__),0};\
          __cbscanf((__cbscanf_get_Callback_t)__sscanf_get,\
                    (__cbscanf_unget_Callback_t)__sscanf_unget,\
                    &__param__,__format__);})
#define vsscanf(__buffer__,__format__,__arglist__) \
        ({__sscanf_string __param__={(__buffer__),0};\
          __vcbscanf((__cbscanf_get_Callback_t)__sscanf_get,\
                     (__cbscanf_unget_Callback_t)__sscanf_unget,\
                     &__param__,(__format__),(__arglist__));})
CALLBACK short __scanf_get(short *param);
CALLBACK void __scanf_unget(short c, short *param);
void __scanf_finish(void);
#define scanf(__format__...) \
        ({short __ungetbuf__=0;\
          short __result__=__cbscanf((__cbscanf_get_Callback_t)__scanf_get,\
                                     (__cbscanf_unget_Callback_t)__scanf_unget,\
                                     &__ungetbuf__,__format__);\
          __scanf_finish();__result__;})
#define vscanf(__format__,__arglist__) \
        ({short __ungetbuf__=0;\
          short __result__=__vcbscanf((__cbscanf_get_Callback_t)__scanf_get,\
                                      (__cbscanf_unget_Callback_t)__scanf_unget,\
                                      &__ungetbuf__,(__format__),(__arglist__));\
          __scanf_finish();__result__;})
