/* 
 * TI-NESulator project : mappers.h
 *
 * UNROM Mapper
 *
 * Code Copyright © 2003 by TRAPIER Manoel
 *
 */

int unrom_InitMapper(NesCart *cart)
{
	mLBank = cart->ROMBanks[0];

	mUBank = cart->ROMBanks[cart->nbROMBanks - 1];
	
	return 0;
}

int unrom_MapperWriteHook(register word Addr,register byte Value)
{
	if ( Addr > 0x7FFF ) /* Try to write to the rom */
	{
		mLBank = Cart->ROMBanks[Value];
		return 1;
	}
	return 0;
}
