/*----------------------------------------
_X_Lib.h
Version: 1.00
Derniere mise a jour: 23/6/2002
-----------------------------------------*/


/* FONCTIONS PRESENTES */

BOOL XGOn();
void XGOff();
void * XNewGPlan();
void * XNewBWPlan();
#define XDestrGPlan(adrr) free(adrr);
#define XDestrBWPlan(adrr ) free(adrr);
void XGPlanc(register void *GPlan asm("a0")); 
void XBWPlanc(register void *BWPlan asm("a0")); 
void XClrGPlan();
void XClrLPlan();
void XClrDPlan();
void XClrBWPlan();
void XCpyGPlanToLCD();
void XCpyGPlanToInvLCD();
void XCpyDPlanToLCD();
void XCpyDPlanToLLCD();
void XCpyLPlanToLCD();
void XCpyLPlanToDLCD();
void XCpyBWPlanToDPlan();
void XCpyBWPlanToLPlan();
void XJoyPad();

/* CONSTANTES DEFINIES */

#define XGPlan 			3840*2
#define XBWPlan			3840

#define LIGHT_PLAN	0
#define DARK_PLAN		1

#define WHITE				0
#define LIGHT_GRAY	1
#define DARK_GRAY		2
#define BLACK				3
#define CHANGE			4


/* TYPES DEFINIS */

typedef unsigned char XGMSprite[96];
typedef unsigned char XGSprite[64];
typedef unsigned char XBWSprite[32];
typedef unsigned char XBWPic[];
typedef unsigned char XBWMatrix[];
typedef unsigned char XBWData[];
typedef unsigned char XGTMatrix[];
typedef unsigned char XGTData[];
typedef unsigned char XGTSprite[];
typedef struct{
		unsigned char hauteur;
		unsigned char *XBWlvl_matrix;
		unsigned char *XBWlvl_data;
		}XBWlvl;
typedef struct{
		unsigned char hauteur;
		unsigned char *XBWlvl_matrix;
		unsigned char *XBWlvl_data;
		}XGTlvl;

typedef struct JoyPad_Button_ {
	char Up;
	char Down;
	char Left;
	char Right;
	char Enter;
	char Esc;
	char Apps;
	char B1;
	char B2;
	char B3;
	char B4;
} JoyPad_Button;

extern JoyPad_Button Press;
